package gov.va.cpe.vpr.frameeng;

import gov.va.cpe.vpr.pom.IPOMObject;
import gov.va.cpe.vpr.pom.POMObjectEvent;

import java.io.IOException;
import java.util.List;
import java.util.Map;

public interface IFrameRunner {
    FrameJob exec(IFrameEvent<?>... events) throws Frame.FrameInitException, Frame.FrameExecException;

    FrameJob exec(List<IFrameEvent<?>> events) throws Frame.FrameInitException, Frame.FrameExecException;

    FrameJob.FrameTask exec(IFrame frame, Map<String, Object> params) throws Frame.FrameInitException, Frame.FrameExecException;

    FrameJob.FrameTask exec(IFrame frame) throws Frame.FrameInitException, Frame.FrameExecException;

    FrameJob.FrameTask exec(String frameid, Map<String, Object> params) throws Frame.FrameInitException, Frame.FrameExecException;

    void pushPOMObjectEvents(List<POMObjectEvent<IPOMObject>> events);

    void pushPOMObjectEvent(POMObjectEvent<IPOMObject> evt);

    public void pushEvents(List<IFrameEvent> events);

    public void pushEvent(IFrameEvent event);

    void close() throws IOException;
}
