package gov.va.cpe.vpr.queryeng.dynamic.columns;

import gov.va.cpe.vpr.PatientService;
import gov.va.cpe.vpr.frameeng.IFrameRunner;
import gov.va.cpe.vpr.queryeng.ColDef;
import gov.va.cpe.vpr.queryeng.ColDef.DeferredViewDefDefColDef;
import org.springframework.context.ApplicationContext;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

public class DeferredBoardColumnTask implements Callable<Map<String, Object>> {

    private boolean started = false;
    private boolean completed = false;
    private boolean pushed = false;
    public DeferredViewDefDefColDef dcol = null;
    public Map<String, Object> roe = null;
    private String boardReqId = null;
    private ApplicationContext ctx;
    private String systemId;
    private Map<String, Object> result;
    private boolean failed;
    private Throwable exception;
    public Future<Map<String, Object>> future;

    public DeferredBoardColumnTask(DeferredViewDefDefColDef dcol, Map<String, Object> roe, String vistaId, String boardReqId, ApplicationContext ctx) {
        this.dcol = dcol;
        this.roe = roe;
        this.systemId = vistaId;
        this.boardReqId = boardReqId;
        this.ctx = ctx;
    }

    public Map<String, Object> getData() {
        Map<String, Object> dat = new HashMap<String, Object>();
        dat.put("pid", roe.get("pid"));
        dat.put("sequence", this.dcol.cdef.sequence);
        dat.put("dataIndex", dcol.cdef.dataIndex);
        dat.put("data", this.result);
        return dat;
    }

    @Override
    public Map<String, Object> call() throws Exception {
        Map<String, Object> rslt = null;
        this.setStarted(true);
        try {
            rslt = this.dcol.cdef.runDeferred(this);
        } catch (Exception e) {
            this.failed = true;
            this.exception = e;
            e.printStackTrace();
        }
        this.setCompleted(true);
        result = rslt;
        return rslt;
    }

    public boolean isStarted() {
        return started;
    }

    public void setStarted(boolean started) {
        this.started = started;
    }

    public boolean isCompleted() {
        return completed;
    }

    public void setCompleted(boolean completed) {
        this.completed = completed;
    }

    public boolean isPushed() {
        return pushed;
    }

    public void setPushed(boolean pushed) {
        this.pushed = pushed;
    }

    public IFrameRunner getRunner() {
        return ctx.getBean(IFrameRunner.class);
    }

    public PatientService getPatientService() {
        return ctx.getBean(PatientService.class);
    }

    public String getSystemId() {
        return systemId;
    }

    public void setSystemId(String systemId) {
        this.systemId = systemId;
    }
}
