package gov.va.cpe.vpr.sync.vista;

import com.fasterxml.jackson.databind.JsonNode;
import gov.va.cpe.vpr.PatientDemographics;

import java.util.Map;

/**
 * API to the VPR extract event stream in VistA.
 */
public interface IVistaVprDataExtractEventStreamDAO {
    /**
     * Interface to <code>VPR GET VERSION</code> Remote Procedure Call.
     * @param vistaId
     * @return
     */
    String fetchVprVersion(String vistaId);
    VistaDataChunk fetchPatientDemographicsWithDfn(String vistaId, String ptDfn);
    VistaDataChunk fetchPatientDemographicsWithIcn(String vistaId, String ptIcn);
    VistaDataChunk fetchOneByUid(String vistaId, String pid, String uid);

    void subscribePatient(String vistaId, String pid);
    void unsubscribePatient(String vistaId, String pid);
    void unsubscribePatient(String vistaId, PatientDemographics pt);
    public JsonNode getVistaHealthCheck(String vistaId, String division);

    VprUpdateData fetchUpdates(String vistaId, String division, String lastUpdate);
}
