package gov.va.hmp.spring;

import gov.va.hmp.plugins.osgi.OsgiFrameworkLauncherFactoryBean;
import org.osgi.framework.BundleContext;
import org.osgi.framework.launch.Framework;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class OsgiConfig {

    @Bean(name = "osgiFrameworkFactory")
    public OsgiFrameworkLauncherFactoryBean osgiFrameworkFactoryBean() {
        return new OsgiFrameworkLauncherFactoryBean();
    }

    @Bean(name = "osgiFramework")
    public Framework osgiFramework() {
        try {
            return osgiFrameworkFactoryBean().getObject();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    @Bean(name = "osgiBundleContext")
    public BundleContext osgiBundleContext() {
        return osgiFramework().getBundleContext();
    }
}
