package gov.va.cpe.vpr.sync.util;

import gov.va.cpe.vpr.sync.util.MsgSrcDest.JDSMsgSrc;
import gov.va.cpe.vpr.sync.util.MsgSrcDest.JSONZIPMsgSrc;
import gov.va.cpe.vpr.sync.util.MsgSrcDest.VistARPCMsgSrc;

import java.io.File;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Ignore;
import org.junit.Test;

import com.codahale.metrics.MetricFilter;

@Ignore // This is more of an integration/performance test.  Keep it out of the automated stuff for now.
public class SyncUtilsTests {
	private static SimpleDateFormat SDF = new SimpleDateFormat("yyyyMMdd.HHmm");
	private Map<String, Object> options = new HashMap<String, Object>();
	private List<String> domains = Arrays.asList("all");
	private List<String> pids = Arrays.asList("100848,100851,100846,100845,100849,100842,100841,100847,100850,8,100844,100852,3,231,229,217,237,253,418,25,205,100843".split(","));
//	private List<String> pids = Arrays.asList("229");
	private String uri = "http://localhost:9080/vpr";
	
	@Test
	public void pomTest() throws Exception {
		String str = "c:\\temp\\vistadevpts.20130814.zip";
		File file = new File(str);
		if (!file.exists()) fetchAllData(uri, str);
		
		String ext = SDF.format(new Date()) + ".csv";
		options.put("threads", "1");
		options.put("csv", "c:\\temp\\csv\\SyncUtilsTests.pomTest." + ext);
		
		// TODO: How to automate truncating the whole JDS store before and in between?
		
		// test script for determining JDS loading from .zip w/ and w/o domain objects
		JSONZIPMsgSrc src = new JSONZIPMsgSrc(str);
		JDSMsgSrc dest = new JDSMsgSrc(uri);
	
		// run w/o POM domains
		SyncUtils util = new SyncUtils(src, dest, options, domains, pids);
		util.exec();
		util.close();
		SyncUtils.METRICS.removeMatching(MetricFilter.ALL);
		
		// then again with POM domains
		options.put("pom", true);
		src = new JSONZIPMsgSrc(str);
		dest = new JDSMsgSrc(uri);
		util = new SyncUtils(src, dest, options, domains, pids);
		util.exec();
		util.close();
	}
	
	// TODO: Should this just be checked into the .resources directory instead?
	private void fetchAllData(String uri, String file) throws IOException, InterruptedException {
		VistARPCMsgSrc src = new VistARPCMsgSrc(uri, options);
		JSONZIPMsgSrc dest = new JSONZIPMsgSrc(file);
		SyncUtils util = new SyncUtils(src, dest, options, domains, pids);
		util.exec();
	}
}
