package gov.va.hmp.vista.springframework.security.web;

import javax.servlet.http.HttpServletRequest;
import java.net.UnknownHostException;

public class VistaAuthenticationHttpRequestUtils {

    public static String obtainRemoteAddress(HttpServletRequest request) {
        String ip = request.getHeader("X-Forwarded-For");
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("Proxy-Client-IP");
        }
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("WL-Proxy-Client-IP");
        }
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("HTTP_CLIENT_IP");
        }
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getHeader("HTTP_X_FORWARDED_FOR");
        }
        if (ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
            ip = request.getRemoteAddr();
        }
        return ip;
    }

    public static  String obtainRemoteHostName(HttpServletRequest request) {
        String host = request.getRemoteHost();
        String ip = request.getRemoteAddr();
        if(ip.equals(host)) {
            try {
                host = java.net.InetAddress.getByName(host).getHostName();
            } catch (UnknownHostException e) {
                e.printStackTrace();
            }
        }
        return host;
    }
}
