package gov.va.hmp.vista.rpc;

import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

public class TestRpcHost {

    private RpcHost host;

    @Before
    public void setUp() throws Exception {
        host = new RpcHost("server_122.vha.domain.ext", 0000);
    }

    @Test
    public void testToURI() {
        assertEquals("vrpcb://server_122.vha.domain.ext:0000", host.toURI());
    }

    @Test
    public void testToHostString() {
        assertEquals("server_122.vha.domain.ext:0000", host.toHostString());
    }

    @Test
    public void testEquals() {
        assertTrue(host.equals(new RpcHost("VHAISLBLL2.VHA.DOMAIN.EXT", 0000)));
        assertFalse(host.equals(new RpcHost("VHAISLBLL22.VHA.DOMAIN.EXT", 0000))); // different hostname
        assertFalse(host.equals(new RpcHost("VHAISLBLL2.VHA.DOMAIN.EXT", 0000))); // different port
    }
}
