# VistA RPC Connection Test

## Samples

### Show Help
```sh
java -jar vista-rpc-connection-test-1.0.0.jar -h
Option                    Description
------                    -----------
-?, -h, --help            Show Help
-F, -f, --file            Path to HMP vista-accounts.json file
-M, -m, --hmpServerId     HMP Server ID
-P, -p, --port <Integer>  RPC Broker Port (default: 0000)
-S, -s, --host, --server  VistA Server
-a, --arg                 RPC Argument <key=value>
-c, --context             RPC Context
-r, --rpc                 RPC Name
-v, --verbose             Verbose output
```

### Test connection to server/port
```sh
java -jar vista-rpc-connection-test-1.0.0.jar -s example.org -p 0000

   DEV    DEV    DEV    DEV    INNOVATIONS-DEV    DEV    DEV    DEV    DEV
   *************************************************************************

                    You have accessed the DEV Cache Account

   Access privilege is based on specified need.  As a user on this system,
   YOU are responsible for complying with all security regulations regard-
   ing access.  YOU are not to share access codes with anyone or to access
   accounts that do not pertain to YOUR job.  YOU are responsible for
   maintaining the integrity, confidentiality, and security of all infor-
   mation contained in this system.

   USERs who use this system inappropriately will have their access ter-
   minated and removed from the system.

   VIEWing this message indicates that YOU agree with the terms of system
   use.

            MISUSE of this system constitutes a Federal Crime.

               ********************************************
               >> CPRS is installed in this account
               >> CPRS GUI IS AT VERSION 30A (OR*3*404)
               >> VeHU Copy Date: 12 May 2011
               ********************************************

            MISUSE of this system constitutes a Federal Crime.

   DEV    DEV    DEV    DEV   INNOVATIONS-DEV     DEV    DEV    DEV    DEV
   *************************************************************************

```

if successful will return the welcome message of the VistA system at hostname/port

### Invoke an RPC that takes no arguments
```sh
java -jar vista-rpc-connection-test-1.0.0.jar -s example.org -p 0000 --context "OR CPRS GUI CHART" -rpc "ORWU USERINFO"
Access Code: *
Verify Code: *
20012^VEHU,TEN^3^1^1^3^0^5400^20^1^1^20^DEV.HMPDEV.VAINNOVATIONS.US^2^240^1^1^^0^0^^1^0^500^^0
```

### Invoke an RPC that takes 1 argument of type array
```sh
java -jar vista-rpc-connection-test-1.0.0.jar -s example.org -p 0000 --context "ZZ CONTEXT" -rpc "ZZ RPC" --arg foo=bar
Access Code: *
Verify Code: *
<RPC RESPONSE>
```