package gov.va.hmp.rpc.ws;

import org.springframework.data.domain.Page;

import java.util.List;

public class CollectionResource<T> {
    private List<T> items;
    private int pageSize;
    private long totalRecords;
    private int currentPage = 0;
    private int firstPage = 0;
    private int lastPage = 0;
    private int totalPages = 1;

    public CollectionResource(List<T> items) {
        this.items = items;
        this.totalRecords = this.pageSize = items.size();
    }

    public CollectionResource(Page<T> page) {
        this.items = page.getContent();
        this.pageSize = page.getSize();
        this.currentPage = page.getNumber();
        this.lastPage = page.getTotalPages() - 1;
        this.totalRecords = page.getTotalElements();
        this.totalPages = page.getTotalPages();
    }

    public List<T> getItems() {
        return items;
    }

    public int getPageSize() {
        return pageSize;
    }

    public long getTotalRecords() {
        return totalRecords;
    }

    public int getCurrentPage() {
        return currentPage;
    }

    public int getFirstPage() {
        return firstPage;
    }

    public int getLastPage() {
        return lastPage;
    }

    public int getTotalPages() {
        return totalPages;
    }
}
