package gov.va.hmp.rpc.ws;

import gov.va.hmp.vista.rpc.RpcHost;

import javax.persistence.Entity;
import javax.persistence.Id;

@Entity
public class VistaAccount {

    @Id
    private String id;
    private String host;
    private Integer port;
    private boolean production = false;

    // required for JPA
    protected VistaAccount() {}

    public VistaAccount(String id, boolean production, String host, Integer port) {
        this.id = id;
        this.production = production;
        this.host = host;
        this.port = port;
    }

    public String getId() {
        return id;
    }

    public String getHost() {
        return host;
    }

    public Integer getPort() {
        return port;
    }

    public boolean isProduction() {
        return production;
    }

    public RpcHost toRpcHost() {
        return new RpcHost(getHost(), getPort());
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof VistaAccount)) return false;

        VistaAccount that = (VistaAccount) o;

        if (production != that.production) return false;
        if (!host.equals(that.host)) return false;
        if (!id.equals(that.id)) return false;
        if (!port.equals(that.port)) return false;

        return true;
    }

    @Override
    public int hashCode() {
        int result = id.hashCode();
        result = 31 * result + host.hashCode();
        result = 31 * result + port.hashCode();
        result = 31 * result + (production ? 1 : 0);
        return result;
    }
}
