package gov.va.hmp.rpc.ws;

import gov.va.hmp.vista.rpc.RpcHost;
import gov.va.hmp.vista.rpc.RpcHostResolver;
import gov.va.hmp.vista.rpc.broker.conn.VistaIdNotFoundException;
import org.springframework.beans.factory.annotation.Autowired;

public class VistaAccountRpcHostResolver implements RpcHostResolver {
    @Autowired
    VistaAccountRepository vistaAccountRepository;

    @Override
    public RpcHost resolve(String vistaId) throws VistaIdNotFoundException {
        VistaAccount vistaAccount = vistaAccountRepository.findOne(vistaId);
        if (vistaAccount == null) throw new VistaIdNotFoundException(vistaId);
        if (vistaAccount.isProduction()) throw new VistaAccountProductionMismatchException(vistaId);
        return vistaAccount.toRpcHost();
    }
}
